// file      : CCF/IDL2/SemanticGraph/Native.hpp
// author    : Boris Kolpackov <boris@dre.vanderbilt.edu>
// cvs-id    : Native.hpp,v 1.2 2004/01/01 00:12:30 boris Exp

#ifndef CCF_IDL2_SEMANTIC_GRAPH_NATIVE_HPP
#define CCF_IDL2_SEMANTIC_GRAPH_NATIVE_HPP

#include "CCF/IDL2/SemanticGraph/Elements.hpp"

namespace CCF
{
  namespace IDL2
  {
    namespace SemanticGraph
    {
      class Native : public virtual Type
      {
      public:
        virtual bool
        complete () const
        {
          return true;
        }

        static Introspection::TypeInfo const&
        static_type_info ();

      protected:
        friend class Graph<Node, Edge>;

        Native ()
        {
          type_info (static_type_info ());
        }
      };
    }
  }
}

#endif  // CCF_IDL2_SEMANTIC_GRAPH_NATIVE_HPP
